Status: Closed Start date: 2010-08-13

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: REST API Estimated time: 0.00 hour

Target version: 1.1.0   

Resolution: Fixed Affected version:  

Description

Currently the JSON API provides less information than the XML API. E.g. custom fields (resolution) isn't accessible by the JSON API.

Example:

http://svn.jdownloader.org/issues/1531.json

http://svn.jdownloader.org/issues/1531.xml

(1.0.0.stable.3936)

Related issues:

Has duplicate Redmine - Defect #7158: Issues Custom fields not in json Closed 2010-12-22

Associated revisions

Revision 4458 - 2010-12-03 14:52 - Jean-Philippe Lang

Converts IssuesController to use the new API template system and makes xml/json responses consistent (#6136).

History

#1 - 2010-08-15 23:31 - Adam Soltys

This appears to be happening because the issue show action has a custom view (show.builder.xml) that is including the issue's relations, custom

fields, etc. whereas the JSON format uses default to_json method on the issue model which doesn't include those things.

I'm going to tackle this by moving the XML builder code into the issue model's to_xml method instead of a view file.  Then I'll make the issue's to_json

method just call the to_xml method and convert the XML to JSON so we only need to maintain the serialization code in one place.

#2 - 2010-08-15 23:46 - Adam Soltys

- File issue_serialization_patch.diff added

I think this patch addresses the issue.  The changes are also available at http://github.com/asoltys/redmine/tree/issue_serialization

#3 - 2010-08-19 03:36 - Eric Davis

- Target version set to Unplanned backlogs

This is a real problem with using the XML views.  Instead of overriding to_xml, I'm wondering if there is a common method we can make so both XML

and JSON formats are always the same.  Example:

def to_xml

  self.to_api_format(:xml)

end

def to_json

  self.to_api_format(:json)

end

def to_api_format(renderer)

  {

    :id => self.id,

    :subject => self.subject,

    # ....

  }

  # ...

end
#4 - 2010-12-03 15:04 - Jean-Philippe Lang

- Status changed from New to Closed

- Target version changed from Unplanned backlogs to 1.1.0

- Resolution set to Fixed

Fixed in r4458. xml and json responses now use the same template.

Files

issue_serialization_patch.diff 7.26 KB 2010-08-15 Adam Soltys
